#ifndef KRABWIDGET_H 
#define KRABWIDGET_H 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <qwidget.h>
#include <qcombo.h>
#include <qradiobt.h>
#include <qgrpbox.h>
#include <qframe.h>
#include <qlistbox.h>
#include <qpushbt.h>
#include <qlined.h>
#include <qchkbox.h>
#include <qstring.h>
#include <qfile.h>
#include <qtimer.h>
#include <qimage.h>

#include <kapp.h>
#include <kfm.h>
#include <kprocess.h>
#include <kmsgbox.h>
#include <kslider.h>
#include <kconfig.h>
#include <ktablistbox.h>
#include <kiconloader.h>
#include <kfiledialog.h>

#include <cddalist.h>
#include <status_window.h>
#include <namewidget.h>

class KrabWidget : public QWidget
{
	Q_OBJECT

public:
	KrabWidget(QWidget *parent = 0, const char *name = 0, TodoList *todolist_p=NULL);
  	virtual ~KrabWidget();

//	QListBox *QListBox_todo;
	KConfig *kconfig;
	KTabListBox *KTabListBox_todo;
	QFrame *QFrame_controll;
	bool working;

signals:
	void new_status_info(QString);
	void enable_widgets( bool );
public slots:
	void DropEvent(KDNDDropZone *);
	void todolist_update();
	void test_enviroment( bool );
	void delete_job( unsigned int );
	void select_files();

private slots:
        void cddalister();
	void sorry();
	void test_env_stdout(KProcess *, char * ,int ); 
	void krabwidget_setEnabled( bool );
	void resizeEvent( QResizeEvent * );

	void doit();
	void doit_control();
	void kill_doit();
	void help_prog_df_stdout(KProcess *, char *, int);
	void doit_read_prog();
	void read_prog_dead();
	void progress_update();
	void doit_write_prog(unsigned int);
	void write_prog_dead();
	void write_mp3_header( QString, unsigned int );
	void send_signal_process( unsigned int );
	void renice_process( int );
	void select_file( QString, unsigned int tracknr=0 );

	void CddaListDestroyed();
	void NameWidgetDestroyed();
	void define_outputpath();
	void define_names();
	void QCheckBox_cdda_jitter_clicked();
	bool QCheckBox_cdda_stereo_clicked();
	bool QCheckBox_cdda_16bit_clicked();
	void QComboBox_cdda_clicked(int z);
	void QComboBox_encoder_clicked(int n);
	void KSlider_smp_moved(int);
	void KSlider_nice_moved(int);

private:
	bool cdparanoia, 
	     cdda2wav, 
	     amp, 
	     hz8_mp3, 
	     l3enc, 
	     bladeenc,
	     mp3enc,
	     doit_control_run,
	     progress_update_run,
	     read_prog_run,
	     write_prog_run[6],
	     temp_file[101];
	TodoList *todolist;
	namewidget *NameWidget;
	cddalist *CddaList;
	KProcess *help_prog,
		 *read_prog,
		 *write_prog[6];
	unsigned int jobnumber,
                     write_jobnumber,
		     write_job_track[6],
		     encoder_max,
		     devices_count,
		     modes[9],
		     cdparanoia_version,
	             read_prog_final_size,
		     write_prog_final_size[6],
		     bitrate,
                     space_required,
                     space_avaible;
	unsigned long int total_final_size,
                     	  total_finished;
	
	int nice_level;
	QString help_prog_stdout_temp,
		blade_prog_stdout_temp,
	        devices[16],
		outputfilename[6],
	        tempfilename[101];
	status_window *Status;
	
	KIconLoader *iloader;
	KSlider *KSlider_nice;
	KSlider *KSlider_smp;
	
	QLabel  *QLabel_nice,
		*QLabel_smp;

	QTimer *QTimer_progress,
	       *QTimer_process;

   	QPushButton *QPushButton_cdda_list;
	QGroupBox *QGroupBox_encoder;
	QComboBox *QComboBox_encoder;

	QGroupBox *QGroupBox_cdda;
	QComboBox *QComboBox_cdda;
	QCheckBox *QCheckBox_cdda_stereo;
	QCheckBox *QCheckBox_cdda_16bit;
	QCheckBox *QCheckBox_cdda_jitter;
	QComboBox *QComboBox_device;

	QComboBox *QComboBox_8hz_br;
	QCheckBox *QCheckBox_8hz_copyright;
	QCheckBox *QCheckBox_8hz_original;

	QComboBox *QComboBox_blade_br;
	QCheckBox *QCheckBox_blade_copyright;
	QCheckBox *QCheckBox_blade_private;
	QCheckBox *QCheckBox_blade_crc;

	QGroupBox *QGroupBox_options;
        QGroupBox *QGroupBox_pref;

	QCheckBox *QCheckBox_wav_raw;

	QComboBox *QComboBox_l3_br;
	QCheckBox *QCheckBox_l3_hq;
	QCheckBox *QCheckBox_l3_crc;
	QCheckBox *QCheckBox_l3_speech;

	QGroupBox *QGroupBox_nice;
	QCheckBox *QCheckBox_mp3_header;

	QComboBox *QComboBox_mp3_br;
	QComboBox *QComboBox_mp3_ql;
	QGroupBox *QGroupBox_cache;

	QPushButton *QPushButton_cd;
	QPushButton *QPushButton_outputpath;
	QPushButton *QPushButton_names;
	QPushButton *QPushButton_doit;

	QPixmap *pix_wav,
		*pix_mp2,
		*pix_mp3,
		*pix_cdda,
		*pix_push_1_off,
		*pix_push_2_off,
		*pix_push_3_off,
		*pix_push_4_off,
		*pix_push_1,
		*pix_push_2,
		*pix_push_3,
		*pix_push_4;

	QFile *read_prog_file,
	      *write_prog_file[6];

  	void initLayout(void);
	void initLayout_wav();
	void initLayout_8hz();
	void initLayout_blade();
	void initLayout_l3();
	void initLayout_mp3();
	void initLayout_wav_del();
	void initLayout_8hz_del();
	void initLayout_blade_del();
	void initLayout_l3_del();
	void initLayout_mp3_del();

	static const unsigned int bitrate_8hz[], bitrate_blade[], bitrate_l3[], bitrate_mp3[], bitrate_mpeg_layer2[], bitrate_mpeg_layer3[];
	static const unsigned int bitrate_8hz_max, bitrate_blade_max, bitrate_l3_max, bitrate_mp3_max; 
};

#endif // KRABWIDGET_H 




